<?php /*

Plugin Loader version 2.0 beta 3 for CMSimple v2.6

Edited by  Jan Neugebauer (4th September 2006)
http://www.internet-setup.de/cmsimple/

Based on original script by  Michael Svarrer
http://cmsimpleplugins.svarrer.dk

Updated 22. September 2006 by Peter Andreas Harteg and released under the CMSimple license in the CMSimple distrubution with permission by copyright holders.

For licence see notice in /cmsimple/cms.php and http://www.cmsimple.dk/?Licence

For changelog please refer to original distribution file available at
http://www.internet-setup.de/cmsimple/

Usage:

This plugin loader will load compatible plugins avaliable under the
plugins folder into CMSimple:

Step 0 - In /cmsimple/config.php set $cf['plugins']['folder']="plugins"; (or set plugins_folder to plugins under CMSimple configuration settings)
Step 1 - Installation is done and you should be ready to install plugins
         Plugins avaliable at:
         http://www.internet-setup.de/cmsimple/
         http://cmsimpleplugins.svarrer.dk
         http://famnissen.dk/cmsimple_addon/
         http://www.jat-at-home.be
         http://www.cmsimple.dk/?Addons_and_plugins

*/

//error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

$pluginloader_cfg=ARRAY();
$pluginloader_tx=ARRAY();

$pluginloader_cfg['languages'] = ARRAY('EN', 'DE', 'FR', 'NL');
/*
 * Set language for the plugin loader
*/
if (isset ($sl)) {
	$pluginloader_cfg['language'] = strtoupper($sl);
} else {
	$pluginloader_cfg['language'] = strtoupper($cf['language']['default']);
}
// Use english language, if $sl or default language are not supported by the Plugin Loader
if (!in_array($pluginloader_cfg['language'], $pluginloader_cfg['languages'])) { $pluginloader_cfg['language']='EN'; }




if ($pluginloader_cfg['language'] == 'EN') {
	$pluginloader_tx['menu']['available_plugins'] = 'Plugins: ';
	$pluginloader_tx['menu']['select_plugin'] = 'Select plugin ...';

	$pluginloader_tx['menu']['tab_main'] = 'Plugin Main settings';
	$pluginloader_tx['menu']['tab_css'] = 'Plugin Stylesheet';
	$pluginloader_tx['menu']['tab_config'] = 'Plugin Config';
	$pluginloader_tx['menu']['tab_language'] = 'Plugin Language';
	$pluginloader_tx['menu']['tab_help'] = 'Plugin Help';

	$pluginloader_tx['success']['saved'] = 'File saved: ';

	$pluginloader_tx['error']['plugin_error'] = 'Plugin error: ';
	$pluginloader_tx['error']['cntopen'] = $tx['error']['cntopen'].' ';
	$pluginloader_tx['error']['cntwriteto'] = $tx['error']['cntwriteto'].' ';
} // if ($pluginloader_cfg['language'] == 'EN')

if ($pluginloader_cfg['language'] == 'DE') {
	$pluginloader_tx['menu']['available_plugins'] = 'Plugins: ';
	$pluginloader_tx['menu']['select_plugin'] = 'Plugin whlen ...';

	$pluginloader_tx['menu']['tab_main'] = 'Plugin-Einstellungen';
	$pluginloader_tx['menu']['tab_css'] = 'Plugin-Stylesheet';
	$pluginloader_tx['menu']['tab_config'] = 'Plugin-Konfiguration';
	$pluginloader_tx['menu']['tab_language'] = 'Plugin-Sprache';
	$pluginloader_tx['menu']['tab_help'] = 'Plugin-Hilfe';

	$pluginloader_tx['success']['saved'] = 'Datei gespeichert: ';

	$pluginloader_tx['error']['plugin_error'] = 'Plugin Fehler: ';
	$pluginloader_tx['error']['cntopen'] = $tx['error']['cntopen'].' ';
	$pluginloader_tx['error']['cntwriteto'] = $tx['error']['cntwriteto'].' ';
} // if ($pluginloader_cfg['language'] == 'DE')

if ($pluginloader_cfg['language'] == 'FR') {
   $pluginloader_tx['menu']['available_plugins'] = 'Plugins disponibles: ';
   $pluginloader_tx['menu']['select_plugin'] = 'Choisir un plugin ...';

   $pluginloader_tx['menu']['tab_main'] = 'Rglages plugin';
   $pluginloader_tx['menu']['tab_css'] = 'Feuille de style plugin';
   $pluginloader_tx['menu']['tab_config'] = 'Configuration plugin';
   $pluginloader_tx['menu']['tab_language'] = 'Langue plugin';
   $pluginloader_tx['menu']['tab_help'] = 'Aide plugin';

   $pluginloader_tx['success']['saved'] = 'Fichier sauvegard: ';

   $pluginloader_tx['error']['plugin_error'] = 'Erreur plugin: ';
   $pluginloader_tx['error']['cntopen'] = $tx['error']['cntopen'].' ';
   $pluginloader_tx['error']['cntwriteto'] = $tx['error']['cntwriteto'].' ';
} // if ($pluginloader_cfg['language'] == 'FR')

if ($pluginloader_cfg['language'] == 'NL') {
	$pluginloader_tx['menu']['available_plugins'] = 'Beschikbare Plugins: ';
	$pluginloader_tx['menu']['select_plugin'] = 'Selecteer plugin ...';

	$pluginloader_tx['menu']['tab_main'] = 'Plugin Instellingen';
	$pluginloader_tx['menu']['tab_css'] = 'Plugin Stijlen';
	$pluginloader_tx['menu']['tab_config'] = 'Plugin Configuratie';
	$pluginloader_tx['menu']['tab_language'] = 'Plugin Talen';
	$pluginloader_tx['menu']['tab_help'] = 'Plugin Help';

	$pluginloader_tx['success']['saved'] = 'Bestand opgeslagen: ';

	$pluginloader_tx['error']['plugin_error'] = 'Plugin fout: ';
	$pluginloader_tx['error']['cntopen'] = $tx['error']['cntopen'].' ';
	$pluginloader_tx['error']['cntwriteto'] = $tx['error']['cntwriteto'].' ';
} // if ($pluginloader_cfg['language'] == 'NL')


$hjs .= '
<style type="text/css">
<!--
.pluginedit {}

.plugintext {}

.plugintextarea {
  width: 400px;
  height: 300px;
}
-->
</style>
';


/*
 * Include plugin (and plugin files)
*/
$handle = opendir($pth['folder']['plugins']);
while ($plugin = readdir($handle)) {
	if ($plugin != "." && $plugin != ".." && is_dir($pth['folder']['plugins'].$plugin)) {
		PluginFiles($plugin);

		// load plugin or die
		if (!@ include ($pth['file']['plugin_index']))
			die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['file']['plugin_index']);

		// If current language file is missing
		// try to copy english language to current language file
		if (!file_exists($pth['file']['plugin_language'])) {
			if (file_exists($pth['folder']['plugins'].$plugin.'/languages/en.php')) {
				$is_copied = @ copy($pth['folder']['plugins'].$plugin.'/languages/en.php', $pth['file']['plugin_language']);
				if ($is_copied == FALSE) {
					// Set language file to "EN" if copying failed
					$pth['file']['plugin_language'] = $pth['folder']['plugins'].$plugin.'/languages/en.php';
				}
			}
		}

		// load plugin language or die
		if (!@ include ($pth['file']['plugin_language'])) {
			//die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['file']['plugin_language']);
		}

		// load plugin config
		if (!@ include ($pth['file']['plugin_config'])) {
			// do nothing
		}
		// add plugin css to the header of CMSimple/Template
		if (file_exists($pth['file']['plugin_stylesheet'])) {
			$hjs .= '<link rel="stylesheet" href="'.$pth['file']['plugin_stylesheet'].'" type="text/css" />';
		}

	} // if ($plugin

} // while ($plugin = readdir($handle))




/*
 * Load the admin functions (admin.php, if exists) of the plugin
 * and create the select box for available plugins.
 *
*/
if ($adm) {
	$i = 0;

	$pluginloader_plugin_selectbox = '';


	//$o .= '<table class="edit" width="100%" cellpadding="1" cellspacing="0" border="1">';
	//$o .= '<tr><td width="100%" align="left">';


	$pluginloader_plugin_selectbox .= $pluginloader_tx['menu']['available_plugins'];
	$pluginloader_plugin_selectbox .= '<form style="display: inline; margin-bottom: 0px;">';
	$pluginloader_plugin_selectbox .= '<select name="Plugins" onchange="location.href=this.options[this.selectedIndex].value" >';
	$pluginloader_plugin_selectbox .= '<option value="?&normal">'.$pluginloader_tx['menu']['select_plugin'].'</option>';
	$handle = opendir($pth['folder']['plugins']);
	$found_plugins = false;
	while ($plugin = readdir($handle)) {
		if ($plugin != '.' && $plugin != '..' && is_dir($pth['folder']['plugins'].$plugin)) {

			PluginFiles($plugin);
			if (file_exists($pth['file']['plugin_admin'])) {
				$pluginloader_plugin_selectbox .= '<option value="'.$sn.'?&amp;'.$plugin.'&amp;normal"';
				reset($_GET);
				list ($firstgetkey) = each($_GET);
				if ($firstgetkey == $plugin)
					$pluginloader_plugin_selectbox .= ' selected="selected"';
				$pluginloader_plugin_selectbox .= '>'.ucwords($plugin).'</option>';
				$admin_plugins[$i] = $plugin;
				$found_plugins = true;
				$i++;
			} // if (file_exists($pth['file']['plugin_admin']))
		}
	}
	$pluginloader_plugin_selectbox .= '</select></form>';
	//$o .= '</td></tr></table>';

	//$plugin_menu_style['row']='class="edit" style="background-color: red;"';
	PluginMenu('ROW', '', '', '', $plugin_menu_style);

	//$plugin_menu_style['data'] = 'style="background-color: lime;"';
	PluginMenu('DATA', '', '', $pluginloader_plugin_selectbox, $plugin_menu_style);

	$o .=	PluginMenu('SHOW');



	// load common plugin admin functions or die
	//if(!@include($pth['folder']['plugins'].'/admin_common.php')) {
	//	die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['folder']['plugins'].'/admin_common.php');
	//}
	if ($found_plugins == true) {
		foreach ($admin_plugins as $plugin) {
			PluginFiles($plugin);
			if (file_exists($pth['file']['plugin_admin'])) {
				@include ($pth['file']['plugin_admin']);
			}
		}
	}

} // if ($adm)




/*
 * Set plugin filenames.
*/
function PluginFiles($plugin) {
	global $cf, $pth, $sl;
	global $pluginloader_cfg;

	$pth['folder']['plugin'] = $pth['folder']['plugins'].$plugin.'/';
	$pth['file']['plugin_index'] = $pth['folder']['plugin'].'index.php';
	$pth['file']['plugin_admin'] = $pth['folder']['plugin'].'admin.php';

	if (file_exists($pth['folder']['plugin'].'languages/'.strtolower($sl).'.php')) {
		$pth['file']['plugin_language'] = $pth['folder']['plugin'].'languages/'.strtolower($sl).'.php';
	}
	else {
		$pth['file']['plugin_language'] = $pth['folder']['plugin'].'languages/'.strtolower($cf['language']['default']).'.php';
	}

	$pth['file']['plugin_config'] = $pth['folder']['plugin'].'config/config.php';
	$pth['file']['plugin_stylesheet'] = $pth['folder']['plugin'].'css/stylesheet.css';

	$pth['file']['plugin_help'] = $pth['folder']['plugin'].'help/help_'.strtolower($pluginloader_cfg['language']).'.htm';
	if (!file_exists($pth['file']['plugin_help'])) {
		$pth['file']['plugin_help'] = $pth['folder']['plugin'].'help/help_en.htm';
	}
} // function PluginFiles(




/*
 * Create Menu of plugin (add row, add tab
*/
function PluginMenu($add='', $link='', $target='', $text='', $style=ARRAY()) {

	/*
	if ($add=='SHOW') {
		print '<pre>';
		debug_print_backtrace();
		print '</pre>';
	}
	*/

	if (!isset($GLOBALS['pluginloader']['plugin_menu'])) { $GLOBALS['pluginloader']['plugin_menu']=''; }
	if (!isset($style['row'])) { $style['row']='class="edit" style="width: 100%;"'; }
	if (!isset($style['tab'])) { $style['tab']=''; }
	if (!isset($style['link'])) { $style['link']=''; }

	$menu_row = '<table {{STYLE_ROW}} cellpadding="1" cellspacing="0" border="1">{{TAB}}</table>';
	$menu_tab = '<td {{STYLE_TAB}}><a {{STYLE_LINK}} href="{{LINK}}" {{TARGET}}>{{TEXT}}</a></td>';
	$menu_tab_data = '<td {{STYLE_DATA}}>{{TEXT}}</td>';


	// Add new row for menu of plugin (or pluginloader)
	if (strtoupper($add) == 'ROW') {
		$new_menu_row = $menu_row;
		$new_menu_row = str_replace('{{STYLE_ROW}}', $style['row'], $new_menu_row);
		$GLOBALS['pluginloader']['plugin_menu'] .= $new_menu_row;
	}

	// Add a new tab to the menu row
	if (strtoupper($add) == 'TAB') {
		$new_menu_tab = $menu_tab;
		$new_menu_tab = str_replace('{{STYLE_TAB}}', $style['tab'], $new_menu_tab);
		$new_menu_tab = str_replace('{{STYLE_LINK}}', $style['link'], $new_menu_tab);
		$new_menu_tab = str_replace('{{LINK}}', $link, $new_menu_tab);
		$new_menu_tab = str_replace('{{TARGET}}', $target, $new_menu_tab);
		$new_menu_tab = str_replace('{{TEXT}}', $text, $new_menu_tab);

		// add tab to row
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', $new_menu_tab.'{{TAB}}', $GLOBALS['pluginloader']['plugin_menu']);
	}

	// Add a new tab to the menu row
	// here: user defineable data
	if (strtoupper($add) == 'DATA') {
		$new_menu_tab_data = $menu_tab_data;
		$new_menu_tab_data = str_replace('{{STYLE_DATA}}', $style['data'], $new_menu_tab_data);
		$new_menu_tab_data = str_replace('{{TEXT}}', $text, $new_menu_tab_data);

		// add tab to row
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', $new_menu_tab_data.'{{TAB}}', $GLOBALS['pluginloader']['plugin_menu']);
	}

	// show complete menu
	if (strtoupper($add) == 'SHOW') {
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', '', $GLOBALS['pluginloader']['plugin_menu']);

		$menu = $GLOBALS['pluginloader']['plugin_menu'];
		$GLOBALS['pluginloader']['plugin_menu']='';
		return $menu;
	}

} // function PluginMenu()



/*
 * Write content to a given file.
*/
function PluginWriteFile($file, $content) {
	global $pluginloader_tx;

	$is_written = ARRAY ();
	$is_written['success'] = FALSE;
	$is_written['msg'] = '';

	if (!file_exists($file)) {
		$is_written['msg'] = $pluginloader_tx['error']['cntopen'].$file;
	} else {

		if (!is_writeable($file)) {
			$is_written['msg'] = $pluginloader_tx['error']['cntwriteto'].$file;
		} else {
			if ($fh = @ fopen($file, "w+b")) {
				@ fwrite($fh, $content);
				@ fclose($fh);

				$is_written['msg'] = $pluginloader_tx['success']['saved'].$file;
				$is_written['success'] = TRUE;
			}
		}
	}

	return $is_written;

} // function PluginWriteFile() {




/*
 * The part below was in file admin_common.php
 * in previous (Svarrers' versions) version of the Plugin Loader.
*/


/*
CMSimple - Plugin Loader Plugin - version 1.0 Beta 4
 2005 - Michael Svarrer
---------------------------------------------------------------------
- Beta 4 : Forth beta released - 15. jun 2005
Some Notice: Undefined variable: for different variables
- Beta 3 : Third beta released - 4. jun 2005
Bugs corrected when running i REGISTER GLOBAL off enviroment
would work thanks to Jan Kanters - JAT
- Beta 2 : Second beta released - 29. may 2005
Changed so a plugin without languages, config & settings files also
would work thanks to Jan Kanters - JAT
- Beta 1 : First beta released - 22. may 2005
---------------------------------------------------------------------
Disclaimer: No warranties at all, use on your own risk !
---------------------------------------------------------------------
Feedback: webmaster@svarrer.dk
---------------------------------------------------------------------
Usage: File part of plugin loader at http://cmsimpleplugins.svarrer.dk/
*/




/*
 * Create plugin menu tabs.
*/
function print_plugin_admin($main) {

	//print "Function: ".__FUNCTION__." Line ".__LINE__.": print_plugin_admin(".$main.") <br />";

	global $sn, $plugin, $pth, $sl;
	global $pluginloader_tx, $plugin_tx;

	initvar('plugin_text');
	initvar('action');
	initvar('admin');
	$t = '';

	$css = '';
	$config = '';
	$language = '';
	$help = '';

	PluginFiles($plugin);


	if (file_exists($pth['file']['plugin_stylesheet'])) {
		$css = 'on';
	}
	if (file_exists($pth['file']['plugin_config'])) {
		//include($pth['file']['plugin_config']);
		$config = 'on';
	}
	if (file_exists($pth['file']['plugin_language'])) {
		//include($pth['file']['plugin_language']);
		$language = 'on';
	}
	if (file_exists($pth['file']['plugin_help'])) {
		$help = 'on';
	}

	//if (empty($main) AND empty($css) AND empty($config) AND empty($language) AND empty($help)) {
	//	$t .= "nothing to configure for this plugin.";
	//}



	// Use preset texts for the menu,
	// if the plugin itself did not define text for the menu
	if (!isset ($plugin_tx[$plugin]['menu_main']))
		$plugin_tx[$plugin]['menu_main'] = $pluginloader_tx['menu']['tab_main'];
	if (!isset ($plugin_tx[$plugin]['menu_css']))
		$plugin_tx[$plugin]['menu_css'] = $pluginloader_tx['menu']['tab_css'];
	if (!isset ($plugin_tx[$plugin]['menu_config']))
		$plugin_tx[$plugin]['menu_config'] = $pluginloader_tx['menu']['tab_config'];
	if (!isset ($plugin_tx[$plugin]['menu_language']))
		$plugin_tx[$plugin]['menu_language'] = $pluginloader_tx['menu']['tab_language'];
	if (!isset ($plugin_tx[$plugin]['menu_help']))
		$plugin_tx[$plugin]['menu_help'] = $pluginloader_tx['menu']['tab_help'];



$plugin_menu_style=ARRAY();
//$plugin_menu_style['row']='class="edit"';
PluginMenu('ROW', '', '', '', $plugin_menu_style);

if ($main == 'on') {
	//$plugin_menu_style=ARRAY();
	//$plugin_menu_style['tab']='style="text-align: left;"';
	//$plugin_menu_style['link']='style="font-weight: bold;"';
	PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_main&action=plugin_text', '', $plugin_tx[$plugin]['menu_main'], $plugin_menu_style);
}

if ($css == 'on') {
	//$plugin_menu_style=ARRAY();
	//$plugin_menu_style['tab']='style="text-align: right;"';
	//$plugin_menu_style['link']='style="color: red;"';
	PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_stylesheet&action=plugin_text', '', $plugin_tx[$plugin]['menu_css'], $plugin_menu_style);
}

if ($config == 'on') { PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_config&action=plugin_edit', '', $plugin_tx[$plugin]['menu_config'], ''); }
if ($language == 'on') { PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_language&action=plugin_edit', '', $plugin_tx[$plugin]['menu_language'], ''); }
if ($help == 'on') { PluginMenu('TAB', $pth['file']['plugin_help'], 'target="_blank"', $plugin_tx[$plugin]['menu_help'], ''); }

$t .= PluginMenu('SHOW');

/*
	$t .= '<table class="edit" width="100%" cellpadding="1" cellspacing="0" border="1">';
	if ($main == 'on')
		$t .= '<td align="center"><a href="'.$sn.'?&'.$plugin.'&admin=plugin_main&action=plugin_text">'.$plugin_tx[$plugin]['menu_main'].'</a></td>';
	if ($css == 'on')
		$t .= '<td align="center"><a href="'.$sn.'?&'.$plugin.'&admin=plugin_stylesheet&action=plugin_text">'.$plugin_tx[$plugin]['menu_css'].'</a></td>';
	if ($config == 'on')
		$t .= '<td align="center"><a href="'.$sn.'?&'.$plugin.'&admin=plugin_config&action=plugin_edit">'.$plugin_tx[$plugin]['menu_config'].'</a></td>';
	if ($language == 'on')
		$t .= '<td align="center"><a href="'.$sn.'?&'.$plugin.'&admin=plugin_language&action=plugin_edit">'.$plugin_tx[$plugin]['menu_language'].'</a></td>';
	if ($help == 'on')
		$t .= '<td align="center"><a href="'.$pth['file']['plugin_help'].'" target="_blank">'.$plugin_tx[$plugin]['menu_help'].'</a></td>';
	$t .= '</table>';
*/

	return $t;
} // function print_plugin_admin()




/*
 * Handle reading and writing of plugin files
 * e.g. en.php, config.php, stylesheet.css
*/
function plugin_admin_common($action, $admin, $plugin) {
	//print "Function: ".__FUNCTION__." Line ".__LINE__.": plugin_admin_common(".$action.",".$admin.",".$plugin.") <br />";

	global $sn, $action, $admin, $plugin, $pth, $ts, $tx;
	global $pluginloader_tx, $plugin_tx;

	$a = '';
	$t = '';

	if ($admin == 'plugin_config')
		$a = 'plugin_cf';
	if ($admin == 'plugin_language')
		$a = 'plugin_tx';
	if ($admin == 'plugin_stylesheet')
		$a = 'plugin_text';
	if ($admin == 'plugin_main')
		$a = 'plugin_text';

	if ($action == 'plugin_save' and $a <> '') {
		$text = "<?php\n";
		foreach ($GLOBALS[$a] as $k1 => $v1) {
			if ($k1 == $plugin)
				if (is_array($v1)) {
					foreach ($v1 as $k2 => $v2) {
						if (!is_array($v2)) {
							initvar($k1.'_'.$k2);
							$GLOBALS[$a][$k1][$k2] = stripslashes($GLOBALS[$k1.'_'.$k2]);
							$text .= '$'.$a.'[\''.$k1.'\'][\''.$k2.'\']="'.preg_replace("/\"/s", "", $GLOBALS[$a][$k1][$k2]).'";'."\n";
						}
					}
				}
		};
		$text .= '?>';

		$is_saved = PluginWriteFile($pth['file'][$admin], $text);
		$t .= '<br /><br />test<br /><br /><b>'.$is_saved['msg'].'</b><br />';
	}

	if ($action == 'plugin_edit' and $a <> '') {
		$t .= '<div class="pluginedit">';
		$t .= '<form action="'.$sn.'?&'.$plugin.'" method="POST">';
		$t .= $ts;

		$t .= "<table class='edit' width='100%' cellpadding='1' cellspacing='0' border='1'>";

		foreach ($GLOBALS[$a] as $k1 => $v1) {
			if ($k1 == $plugin) {
				$t .= '<tr><td colspan="2"><h4>'.ucfirst(str_replace("_", " ", $k1)).'</h4></td></tr>';
				if (is_array($v1)) {
					foreach ($v1 as $k2 => $v2) {
						if (!is_array($v2)) {
							$t .= '<tr><td valign="top">'.str_replace("_", " ", $k2).':</td><td>';
							$t .= tag('input type="text" class="text" name="'.$k1.'_'.$k2.'" value="'.$v2.'" size="50"');
							$t .= '</td></tr>';
							if (isset($plugin_tx['jn_menu_select_box']['cfg_'.$k2]) AND !empty($plugin_tx['jn_menu_select_box']['cfg_'.$k2])) {
								$t .= '<tr><td colspan="2">'.$plugin_tx['jn_menu_select_box']['cfg_'.$k2].'</td></tr>';
							}
						} // if (!is_array($v2))
					} // foreach
				} // if (is_array($v1))
			} // if ($k1 == $plugin)
		}
		$t .= '</table>';
		$t .= tag('input type="hidden" name="admin" value="'.$admin.'"');
		$t .= tag('input type="hidden" name="action" value="plugin_save"').' '.tag('input type="submit" class="submit" value="'.ucfirst($tx['action']['save']).'"');
		$t .= '</form>';
		$t .= '</div>';
	} // if($action=='plugin_edit' and $a<>'')

	if ($action == 'plugin_text' and $a <> '') {

		$t .= '<div class="plugintext">';
		$t .= '<form action="'.$sn.'?&'.$plugin.'" method="post"><h4>'.ucfirst(str_replace("_", " ", $plugin)).'</h4>';
		$t .= '<textarea class="plugintextarea" name="plugin_text">'.rmnl(rf($pth['file'][$admin])).'</textarea>';
		$t .= tag('input type="hidden" name="admin" value="'.$admin.'"');
		$t .= tag('input type="hidden" name="action" value="plugin_textsave"').'<br />'.tag('input type="submit" class="submit" value="'.ucfirst($tx['action']['save']).'"');
		$t .= '</form>';
		$t .= '</div>';
	}

	if ($action == 'plugin_textsave' and $a <> '') {
		$is_saved = PluginWriteFile($pth['file'][$admin], $GLOBALS[$a]);
		$t .= '<br /><b>'.$is_saved['msg'].'</b><br />';
	} // if($action=='plugin_textsave' and $a<>'')

	return $t;

} // function plugin_admin_common()

?>