<?php
/*
* imageWatermark.php v1.1
* Wizzud : 14/03/06 Image Watermark
*          20/04/06 Switched order of 'if' statements around in throwWatermarkImagePathP to handle lastProduct and randomProduct
*/
@include_once (DIR_PLUGINS.'imageWatermark/lang-en.php'); // default
@include_once (DIR_PLUGINS."imageWatermark/lang-{$config['language']}.php");
@include_once (DIR_PLUGINS.'imageWatermark/config.php');

if( !function_exists( 'throwLightboxGallery' ) ){
  /* 'Run Before' function
  *   NOTE: This function is either called directly as a 'Run Before' function, or from
  *         another 'Run Before' function (eg. throwWatermarkImagePathC())
  * @param array
  * @return void
  */
  function throwLightboxGallery($inProgress){
    global $oFF, $aList;

    if(isset($aList['sPhotoBig'])){
      $aList['sLightboxPath'] = $aList['sPhotoBig'];
    }elseif(substr($aList['sPhotoSmall'],0,21) == 'index.php?p=watermark'){
      $aList['sLightboxPath'] = preg_replace('/(p=watermark[\d]+)s([\d]+[c|p])/', '$1b$2', $aList['sPhotoSmall']);
    }else{
      $aName = $oFF->throwNameExtOfFile( $aList['sPhotoSmall'] );
      if(substr($aName[0],-2) == '_m'){
        $aList['sLightboxPath'] = substr($aName[0],0,-2).'.'.$aName[1];
      }else{
        $aList['sLightboxPath'] = $aName[0].'.'.$aName[1];
      }
    }
  }
}

if( !function_exists('throwWatermarkImagePathG') ){
  /*
  * client run-before function, on intercept of tpl call to gallery.tpl, blocks PHOTO_DEFAULT and PHOTO_LIST
  * @return void
  */
  function throwWatermarkImagePathG(){
    global $aList, $iType, $config;
    // format of p is : watermark<imageID><b=big|s=small><productID><c=category|p=product>
    $sCatProd = (isset($iType) && $iType == 2) ? 'c' : 'p';
    if( ($sCatProd == 'p' && $config['Watermark_ProductImages'] == 'all') ||
        ($sCatProd == 'c' && $config['Watermark_ContentImages'] == 'all') ){
      $aList['sPhotoSmall'] = 'index.php?p=watermark'.$aList['iFile'].'s'.$aList['iPosition'].$sCatProd; }
    if( ($sCatProd == 'p' && $config['Watermark_ProductImages'] != 'none') ||
        ($sCatProd == 'c' && $config['Watermark_ContentImages'] != 'none') ){
      $aList['sPhotoBig'] = 'index.php?p=watermark'.$aList['iFile'].'b'.$aList['iPosition'].$sCatProd; }
  } // end function throwWatermarkImagePathG
}

if( !function_exists('throwWatermarkImagePathC') ){
  /*
  * client run-before function, on intercept of tpl calls that relate to categories
  * @param array
  * @return void
  */
  function throwWatermarkImagePathC($inProgress){
    global $aList, $config;
    // format of p is : watermark<imageID><b=big|s=small><productID><c=category|p=product>
    // if we have no imageID then use 0 (zero) and the first image on file will be picked up
    if(isset($aList['iFile']) && isset($aList['iPosition'])){
      if($config['Watermark_ContentImages'] == 'all'){
        $aList['sPhotoSmall'] = 'index.php?p=watermark'.$aList['iFile'].'s'.$aList['iPosition'].'c'; }
      if($config['Watermark_ContentImages'] != 'none'){
        $aList['sPhotoBig'] = 'index.php?p=watermark'.$aList['iFile'].'b'.$aList['iPosition'].'c'; }
    }elseif(isset($aList['iCategory'])){
      if($config['Watermark_ContentImages'] == 'all'){
        $aList['sPhotoSmall'] = 'index.php?p=watermark0s'.$aList['iCategory'].'c'; }
      if($config['Watermark_ContentImages'] != 'none'){
        $aList['sPhotoBig'] = 'index.php?p=watermark0b'.$aList['iCategory'].'c'; }
    }
    if($config['Watermark_Lightbox']){ throwLightboxGallery($inProgress); }
  } // end function throwWatermarkImagePathC
}

if( !function_exists('throwWatermarkImagePathP') ){
  /*
  * client run-before function, on intercept of tpl calls that relate to products
  * @param array
  * @return void
  */
  function throwWatermarkImagePathP($inProgress){
    global $aList, $config;
    // format of p is : watermark<imageID><b=big|s=small><productID><c=category|p=product>
    // if we have no imageID then use 0 (zero) and the first image on file will be picked up
    if(isset($aList['iFile']) && isset($aList['iPosition'])){
      if($config['Watermark_ProductImages'] == 'all'){
        $aList['sPhotoSmall'] = 'index.php?p=watermark'.$aList['iFile'].'s'.$aList['iPosition'].'p'; }
      if($config['Watermark_ProductImages'] != 'none'){
        $aList['sPhotoBig'] = 'index.php?p=watermark'.$aList['iFile'].'b'.$aList['iPosition'].'p'; }
    }elseif(isset($aList['iProduct'])){
      if($config['Watermark_ProductImages'] == 'all'){
        $aList['sPhotoSmall'] = 'index.php?p=watermark0s'.$aList['iProduct'].'p'; }
      if($config['Watermark_ProductImages'] != 'none'){
        $aList['sPhotoBig'] = 'index.php?p=watermark0b'.$aList['iProduct'].'p'; }
    }
    if($config['Watermark_Lightbox']){ throwLightboxGallery($inProgress); }
  } // end function throwWatermarkImagePathP
}

if( !function_exists('throwWatermarkImage') ){
  /*
  * finds the requested image file
  * @param integer image id
  * @param integer product id
  * @param string 'b'ig or 's'mall
  * @return void
  */
  function throwWatermarkImage($iImageID, $iProdID, $sBS, $sCP){
    $found = false;
    $iType = ($sCP == 'c') ? 2 : 1;
    $aData = $iType == 1 ? throwProduct($iProdID) : throwCategory( $iProdID, true, true );
    if(isset($aData) && is_array($aData)){
      $aData = dbListFiles( $iProdID, $iType );
      if(isset($aData[1]) && is_array($aData[1])){
        $count = count($aData[1]);
        for($i=0; (!$found && $i<$count);$i++){
          list($id, $product, $file, $description, $type) = $aData[1][$i];
          if($id == $iImageID || $iImageID == 0){ $found = true; }
        }
      }
    }
    if(isset($aData)){ unset($aData); }
    if($found){ dumpWatermarkedImageFile($file, $sBS, $iType); }
  } // end function throwWatermarkImage
}

if( !function_exists('dumpWatermarkedImageFile') ){
  /*
  * outputs watermarked image if possible, else plain image
  * @param string file name
  * @param string big or small
  * @return void
  */
  function dumpWatermarkedImageFile($sFile, $sBS, $iType){
    global $oFF, $config;
    $sImageDir = throwFilesDir($iType);
    $aName = $oFF->throwNameExtOfFile($sFile);
    $sFileName = ($sBS == 'b') ? $sFile : $aName[0].'_m.'.$aName[1];
    $sBigSmall = ($sBS == 'b') ? 'Big' : 'Small';
    $sFilePath = $sImageDir.$sFileName;
    if(file_exists($sFilePath)){
      if(($oWM = new Watermark(DIR_PLUGINS.'imageWatermark/'.$config["Watermark_Image$sBigSmall"])) !== false){
        $oWM->setWatermarkPosition($config["Watermark_Hpos$sBigSmall"], $config["Watermark_Vpos$sBigSmall"]);
        $oWM->setJpgQuality($config['Watermark_JPGquality']);
        if($oWM->applyWatermark($sFilePath)){
          $oWM->cleanUp();
        }else{
          $oWM->cleanUp();
          dumpUnwatermarkedImageFile($sFilePath, $sFileName, $aName[1]);
        }
        unset($oWM);
      }else{
        dumpUnwatermarkedImageFile($sFilePath, $sFileName, $aName[1]);
      }
    }
  } // end function dumpWatermarkedImageFile
}

if( !function_exists('dumpUnwatermarkedImageFile') ){
  /*
  * outputs image file
  * @param string file path
  * @return void
  */
  function dumpUnwatermarkedImageFile($sFilePath, $sName, $sExt){
    ob_start();
    readfile($sFilePath);
    $iImageSize = ob_get_length();
    $sImage = ob_get_clean();
    header('Content-Type: image/'.(($sExt=='jpg') ? 'jpeg' : $sExt));
    header('Content-Length: '.$iImageSize);
    header('Content-Disposition: attachment; filename='.$sName);
    echo $sImage;
    unset($sImage, $iImageSize);
  } // end function dumpUnwatermarkedImageFile
}
?>
