<?php

if( !function_exists( 'listProducts' ) ){
  /**
  * List products and return content
  * @return string
  * @param string $sFile
  * @param string $sOption
  * @param mixed  $mValue
  * @param int    $iList
  */
  function listProducts( $sFile = 'products_list.tpl', $sOption = 'list', $mValue = null, $iList = null ){

    if( !isset( $GLOBALS['iPage'] ) || !is_numeric( $GLOBALS['iPage'] ) || $GLOBALS['iPage'] < 1 )
      $GLOBALS['iPage'] = 1;

    $iStatus = throwStatus( );

    if( !isset( $iList ) ){
      if( $iStatus == 1 )
        $iList = PRODUCTS_LIST;
      else
        $iList = ADMIN_LIST;
    }

    if( $sOption == 'category' ){
      $aData        = dbListProductsCategory( $iStatus, $mValue, $iList );
      $sPage        = $GLOBALS['p'].'&amp;iCategory='.$GLOBALS['iCategory'];
    }
    elseif( $sOption == 'search' ){
      $aData = dbListProductsSearch( $iStatus, trim( $mValue ), $iList );
      $sPage = $GLOBALS['p'].'&amp;sWord='.$GLOBALS['sWord'];
    }
    else{
      $aData = dbListProducts( $iStatus, $iList );
      $sPage = $GLOBALS['p'];
    }

    if( isset( $aData ) && is_array( $aData ) ){
      $content = throwProductsData( $sFile, $aData, $sPage, $iList );
      }elseif ($sOption=='category'){
              $content = $GLOBALS['tpl']->tbHtml( 'products_category.tpl', 'COLUMNS_TWO');
              }
    else
      $content = $GLOBALS['tpl']->tbHtml( $sFile, 'NOT_FOUND' );

    return $content;
  } // end function listProducts
}
if( !function_exists( 'dbListProductsCategory' ) ){
  /**
  * Return array of products list, search by category
  * @return array
  * @param int  $iStatus
  * @param int  $iCategory
  * @param int  $iList
  */
  function dbListProductsCategory( $iStatus, $iCategory, $iList ){
    global $oFF;
    $aCategories = dbThrowProductsCategories( null );
    return $oFF->throwFileArrayFunctionPages( DB_PRODUCTS, null, $GLOBALS['iPage'], $iList, 'dbListProductsCategoryCheck', Array( $iStatus, $aCategories, $iCategory ) );
  } // end function dbListProductsCategory
}


?>