<?php
/**
* online_statistics.php for onlineStatistics Plugin
* adaptation and modification after [SimonStenhouse.NET] Statistics script
* Claps 10/07/06
*/

@include_once (DIR_PLUGINS.'onlineStatistics/lang-en.php'); // default
@include_once (DIR_PLUGINS."onlineStatistics/lang-{$config['language']}.php");
@include_once (DIR_PLUGINS.'onlineStatistics/config.php');
@include_once (DIR_PLUGINS.'onlineStatistics/geoip.inc');

function statistics_check_file($file)
{
        if (!file_exists($file))
        {
                $handle = fopen($file, "w");
                fclose($handle);
                @chmod($file, 0666);
                return false;
        }
        return true;
}

if( !function_exists( 'throwOnlineStatistics' ) ){
  /*
  * Sets the global variable $sOnlineStatistics with online guests, today unique hits, yesterday unique hits, total unique hits
  * return void
  */
  function throwOnlineStatistics() {
    global $tpl, $sOnlineStatistics, $online, $today, $yesterday,$total, $ip, $two_letter_country_code;
    $ip            = $_SERVER['REMOTE_ADDR'];
    $two_letter_country_code = iptocountry($ip);
    $online        = 0;
    $today         = 0;
    $yesterday     = 0;
    $total         = 0;
    $stored_ip= null;
    $stored_time= null;
    $stored_country= null;
    $minutes       = 15;
    $timp          = time();
    $detail        = "";
    $match         = false;
    $match_today   = false;
    $xlist= array("0","0","0","0","0");

    // If the detail file doesn't exist, it will be created
    statistics_check_file(DB_FILE_DETAIL);

    // Read data from detail file into an array
    $detail = explode("\n", file_get_contents(DB_FILE_DETAIL));

    // Open the detail file for modification
    $handle_detail = fopen(DB_FILE_DETAIL, "w");

    $datetoday=mktime (0,0,0,date("m"),date("d"),  date("Y"));
    $dateyesterday=mktime (0,0,0,date("m"),date("d")-1,  date("Y"));
    $dateweek = mktime (0,0,0,date("m"),date("d")-6,  date("Y"));
    // Loop through the detail array
    for ($x = 0; $x < sizeof($detail); $x++)
    {
        $xlist =explode('|', $detail[$x]);
        // Split and store array values
        $stored_ip =@$xlist[1];
        $stored_time =@$xlist[0];
        $stored_country = @$xlist[2];

           // If the users ip matches a stored ip...
        if ($stored_ip == $ip)
           {
                $match = true;
                // And the user is already visited today...
                if ($stored_time >= $datetoday)
                {
                        $match_today = true;
                        // Update time of visit
                        $stored_time = $timp;
                }
           }
           // If stored visit was today...
           if ($stored_time >= $datetoday)
           {
                // Write back into detail file
                fwrite($handle_detail, "$stored_time|$stored_ip|$stored_country\n");

                // Increment the Today count
                $today++;

                // If the user was online within the last 15 minutes...
                if ($timp < $stored_time + ($minutes * 60))
                {
                        // Increment the Online count
                        $online++;
                }
           }
           // If stored visit was yesterday...
           elseif (($stored_time >= $dateyesterday) && ($stored_time <= $datetoday))
           {
                // Write back into detail file
                fwrite($handle_detail, "$stored_time|$stored_ip|$stored_country\n");

                // Increment the Yesterday count
                $yesterday++;
                }
                // If stored visit was within a week ...
           elseif ($stored_time >= $dateweek)
           {
           // Write back into detail file
            fwrite($handle_detail, "$stored_time|$stored_ip|$stored_country\n");
        }

        }

        // If the user is not recorded as having visited OR if the user is recorded as having visited yesterday but not today...
        if (!$match || $match && !$match_today)
        {
           // Write todays visit into detail file
           fwrite($handle_detail, "$timp|$ip|$two_letter_country_code\n");

           // Increment the Online, Today, and Total count
           $online++;
           $today++;
           $total++;
           }

           // Close the detail file
           fclose ($handle_detail);

           // If the total file doesn't exist, it will be created and the default value of 0 will be written into it
           if (!statistics_check_file(DB_FILE_TOTAL))
           {
           $handle_total = fopen(DB_FILE_TOTAL, "w");
           flock($handle_total, LOCK_EX);
           fwrite($handle_total, "0");
           fclose($handle_total);
           }

           // Read data from total file
           $total += file_get_contents(DB_FILE_TOTAL);
           // Update the total file
           $handle_total = fopen(DB_FILE_TOTAL, "w");
           flock($handle_total, LOCK_EX);
           fwrite($handle_total, $total);
           fclose($handle_total);
           // If number formatting is turned on, apply the formatting
           if (USE_NUMBER_FORMAT)
           {
            $online = number_format($online);
            $today = number_format($today);
            $yesterday = number_format($yesterday);
            $total = number_format($total);
            }

    $sOnlineStatistics = $tpl->tbHtml('online_statistics.tpl','ONLINE_STATISTICS');
  } // end function throwOnlineStatistics
}

function listStatistics( $sFile = 'online_statistics.tpl', $sOption = 'list'){
  global $tpl, $aList, $iday, $imonth, $iyear, $file_to_check, $sToday,$sYesterday,$sWeek,$ctr, $ctr1,$weekst,$weekst1, $dayst,$dayst1, $graph1, $graph2,$graph3,$keys,$values;
// start code
  if( !isset( $GLOBALS['iPage'] ) || !is_numeric( $GLOBALS['iPage'] ) || $GLOBALS['iPage'] < 1 )
  $GLOBALS['iPage'] = 1;
  $content= null;
  if (isset($sOption)){
      if ($sOption =='list'){
      statistics_check_file(DB_FILE_DETAIL);
      $aData = $GLOBALS['oFF']->throwFileArrayClausePages(DB_FILE_DETAIL, 'rsort', $GLOBALS['iPage'], ADMIN_LIST, null,        null );
      $iCount = count( $aData );
      if (isset($iCount)&&($iCount > 0 )){
      $content .= $tpl->tbHtml( $sFile, 'STATISTICS_HEAD' );
      for( $i = 0; $i < $iCount; $i++ ){
           $aList =explode('|', $aData[$i][0]);
           $aList[0] = date( 'Y-m-d H:i:s',$aList[0]);
           if ($aList[2] =="unknown")
           {
           $file_to_check = DIR_PLUGINS.'onlineStatistics/flags/noflag.gif';
           }
           else
           {
           $file_to_check=DIR_PLUGINS.'onlineStatistics/flags/'.$aList[2].'.gif';
           }
      $content .= $tpl->tbHtml( $sFile, 'STATISTICS_LIST' );
      }
      $aList['sPages'] = countPages( $aData[0]['iFindAll'], ADMIN_LIST, $GLOBALS['iPage'], $GLOBALS['p']);
      $content .= $tpl->tbHtml( $sFile, 'STATISTICS_FOOTER' );
      return $content;
    }
    else{
    $content .= $tpl->tbHtml( $sFile, 'NOT_FOUND' );
    return $content;
    }
    }// list
    elseif($sOption =='graph'){
    statistics_check_file(DB_FILE_DETAIL);
    $aData = $GLOBALS['oFF']->throwFileArray(DB_FILE_DETAIL, 'sort');
    $iCount = count( $aData );
    $datetoday=mktime (0,0,0,date("m"),date("d"),  date("Y"));
    $dateyesterday=mktime (0,0,0,date("m"),date("d")-1,  date("Y"));
    $dateweek = mktime (0,0,0,date("m"),date("d")-6,  date("Y"));
    $ctr=null;
    $weekst=null;
    $dayst=null;
    if (isset($iCount)&&($iCount > 0 )){
    $sToday=0;
    $sYesterday=0;
    $sWeek=0;
            for( $i = 0; $i < $iCount; $i++ ){
            $aList =explode('|', $aData[$i][0]);
            // retrieve country id from detail
            $ctr[]= $aList[2];
            // calculate statistics
            if ($aList[0]>=$datetoday) {
                    $dayst[]=date('H',$aList[0]);
                    $sToday++;
                    }
            if ($aList[0]>=$dateyesterday && $aList[0]<=$datetoday) {$sYesterday++;}
            if ($aList[0]>=$dateweek) {
                    $weekst[]=date('Y-m-d',$aList[0]);
                    $sWeek++;
                    }

    }
   // count hits by country
   if (isset($ctr)){
   $ctr1 = array_count_values($ctr);
   ksort($ctr1);
   }
   else
   {$ctr[0]='RO';}
   // past week hits
   $weekst1 =array_count_values($weekst);
   ksort($weekst1);
   // day hits by hour
   if (isset($dayst)){
   $dayst1 =array_count_values($dayst);
   for ($i=0; $i < 24; $i++){
           if (!array_key_exists(sprintf("%02d",$i),$dayst1))
           {
            $dayst1[sprintf("%02d",$i)]=0;
            }
           }
   ksort($dayst1);
   }
   else
   {
       for ($i=0; $i < 24; $i++){
              $dayst1[sprintf("%02d",$i)]=0;
               }
           }

     $values=array_values($dayst1);
     $keys=array_keys($dayst1);

     $graph1="<script>\n";
     $graph1 .= "var g = new graph();";
     for ($i=0; $i<count($values);$i++){
     $graph1 .= "g.add(\"$keys[$i]\",\"$values[$i]\");";}
     $graph1 .= "g.render(\"Graph1\", \"\"); ";
     $graph1 .= "</script>";

     $values=array_values($weekst1);
     $keys=array_keys($weekst1);
     $graph2="<script>\n";
     $graph2 .= "var g = new pie();";
     for ($i=0; $i<count($values);$i++){
     $graph2 .= "g.add(\"$keys[$i]\",\"$values[$i]\");";}
     $graph2 .= "g.render(\"Graph2\", \"\"); ";
     $graph2 .= "</script>";

      $values=array_values($ctr1);
      $keys=array_keys($ctr1);
      $graph3="<script>\n";
     $graph3 .= "var g = new graph();";
     for ($i=0; $i<count($values);$i++){
     $graph3 .= "g.add(\"$keys[$i]\",\"$values[$i]\");";}
     $graph3 .= "g.render(\"Graph3\",\"\"); ";
     $graph3 .= "</script>";


    $content .= $tpl->tbHtml( $sFile, 'STATISTICS_GRAPH' );
    return $content;
    }
    else{
    $content .= $tpl->tbHtml( $sFile, 'NOT_FOUND' );
    return $content;
    }
    }// graph

    }// soption

} // end function liststatistics



function iptocountry($ip) {
    $gi = geoip_open(DIR_PLUGINS.'onlineStatistics/GeoIP.dat',GEOIP_STANDARD);
    $two_letter_country_code = geoip_country_code_by_addr($gi,$ip);
    geoip_close($gi);
    if ($two_letter_country_code==false){
            $two_letter_country_code = "unknown";
    }
    return $two_letter_country_code;
}
?>