<?php
/**
* attributes.php
* Wizzud 31/01/06 Product-Attributes plugin
*        11/04/06 Mod for v2.1 - split the throwAttrSpecialPrice Run Before function into 2 separate functions depending on use of $aData or $aList array
*/
if( !function_exists( 'productHasAttributes' ) ){
  /* Checks to see if a product has attributes assigned or not
  * @param integer $iProduct
  * @return boolean
  */
  function productHasAttributes( $iProduct=null ){
    global $oAttributes;

    if(!isset($iProduct) && isset($GLOBALS['iProduct'])) $iProduct = $GLOBALS['iProduct'];
    if(isset($iProduct)){
      return ($oAttributes->productHasAttributes($iProduct));
    }else{
      return false;
    }
  } // end function productHasAttributes
}
if( !function_exists( 'throwAttrSpecialPriceData' ) ){
  /* 'Run Before' function that calls throwAttrSpecialPrice, if product and price are set
  *   NOTE: This function will only run properly as 'run-before' function, specified as part of a TPL intercept!
  *         It is not intended to be called from in-line code.
  * @param array
  * @return void
  */
  function throwAttrSpecialPriceData($inProgress){
    global $aData;
    if(isset($aData['iProduct']) && isset($aData['fPrice'])){
      throwAttrSpecialPrice($inProgress['newFile'], true);
    }
  }
}
if( !function_exists( 'throwAttrSpecialPriceList' ) ){
  /* 'Run Before' function that calls throwAttrSpecialPrice, if product and price are set
  *   NOTE: This function will only run properly as 'run-before' function, specified as part of a TPL intercept!
  *         It is not intended to be called from in-line code.
  * @param array
  * @return void
  */
  function throwAttrSpecialPriceList($inProgress){
    global $aList;
    if(isset($aList['iProduct']) && isset($aList['fPrice'])){
      throwAttrSpecialPrice($inProgress['newFile'], false);
    }
  }
}
if( !function_exists( 'throwAttrSpecialPrice' ) ){
  /* Modifies the price for a product to the special price (if there is one)
  * @param string replacement template file
  * @param boolean use $aData or $aList
  * @return void
  */
  function throwAttrSpecialPrice($template, $bData=false){
    global $tpl, $oAttributes, $aData, $aList;

    if($bData){ $myData =& $aData; }
    else{ $myData =& $aList; }

    if(($myData['fSpecialPrice'] = $oAttributes->getSpecialPrice($myData['iProduct'])) !== false){
      $myData['sFormattedPrices'] = $tpl->xtbHtml($template, 'FORMATTED_SPECIAL_PRICE');
    }else{
      $myData['sFormattedPrices'] = $tpl->xtbHtml($template, 'FORMATTED_STANDARD_PRICE');
    }
  } // end function throwAttrSpecialPrice
}
?>
