<?php
/**
* templateEdit.php
* Wizzud 04/07/05
* Mod: 15/01/06 - rewritten for QCv1.0
*/
@include_once (DIR_PLUGINS.'templateEdit/config.php');
@include_once (DIR_PLUGINS.'templateEdit/lang-en.php'); // default
@include_once (DIR_PLUGINS."templateEdit/lang-{$config['language']}.php");

if( !function_exists( 'listTemplates' ) ){
  /**
  * list templates
  * @return string
  * @param dir
  */
  function listTemplates( $theme, $name='', $tplFile='templateEdit.tpl' ){
    global $tpl,$aTemplates;

    function listTemplatesEntry($aList, $tplFile, $image=false){
      global $tpl,$aTemplates;
      $rtn = ''; $i=0;
      foreach($aList as $aTemplates['file']=>$a){
        $aTemplates['path'] = $a['path'];
        $aTemplates['class'] = ( $i % 2 );
        $aTemplates['access'] = ($a['dWrite'] && $a['fWrite']) ? 'green' : 'red';
        $aTemplates['fileUE'] = urlencode($aTemplates['file']);
        $aTemplates['pathUE'] = urlencode($aTemplates['path']);
        if($image){
          $aTemplates['img'] = templateImageResize($aTemplates['path']);
          $rtn .= $tpl->tbHtml( $tplFile, 'LIST_LIST_IMG' );
        }else{
          $rtn .= $tpl->tbHtml( $tplFile, 'LIST_LIST' );
        }
        $i++;
      }
      return $rtn;
    } // end of function ListTemplatesEntry

    $path = $theme=='default' ? rtrim($GLOBALS['config']['dir_tpl'].$name,'/') : $GLOBALS['config']['dir_tpl'].$GLOBALS['config']['themesFolder'].rtrim("/$theme/$name",'/');
    $aTemplates = array('name'=>$name, 'theme'=>$theme, 'header_newfile'=>$tpl->tbHtml($tplFile,'LIST_HEAD_NEWFILE'));
    $aTPL = getFiles("$path/", $GLOBALS['config']['template_suffixes']);
    $aCSS = getFiles("$path/", $GLOBALS['config']['css_suffixes']);
    $aIMG = getFiles("$path/img/", $GLOBALS['config']['image_suffixes']);

    // Template files
    $aTemplates['header'] = $GLOBALS['lang']['TemplateTPL'];
    $aTemplates['left'] = $tpl->tbHtml( $tplFile, 'LIST_HEAD' ) . ListTemplatesEntry($aTPL, $tplFile) . $tpl->tbHtml( $tplFile, 'LIST_FOOTER' );

    // Stylesheets
    $aTemplates['header'] = $GLOBALS['lang']['TemplateCSS'];
    $aTemplates['right'] = $tpl->tbHtml( $tplFile, 'LIST_HEAD' ) . ListTemplatesEntry($aCSS, $tplFile) . $tpl->tbHtml( $tplFile, 'LIST_FOOTER' );

    // Images
    $aTemplates['header'] = $GLOBALS['lang']['TemplateIMG'];
    $aTemplates['header_newfile'] = '';
    $aTemplates['right'] .= $tpl->tbHtml( $tplFile, 'LIST_HEAD' ) . ListTemplatesEntry($aIMG, $tplFile, true) . $tpl->tbHtml( $tplFile, 'LIST_FOOTER' );

    $content = $tpl->tbHtml( $tplFile, 'TEMPLATES_LIST' );

    unset($aTPL, $aCSS, $aIMG, $aTemplates);

    return $content;
  } // end function addTemplate
}

if(!function_exists('throwTemplateThemes')){
  function throwTemplateThemes($sTheme, $sFile, $bSaveAs=false){
    global $oPlugMan, $tpl, $aTemplates;
    $aThemes = $oPlugMan->getThemes(true); // get all themes, including invalid ones
    $rtn = $tpl->tbHtml($sFile, ($bSaveAs?'SELECT_THEME_SAVEAS':'SELECT_THEME_HEAD'));
    foreach($aThemes as $n=>$v){
      $aTemplates['selected'] = "value='$v'" . ($v == $sTheme ? " selected='selected'" : '');
      $aTemplates['option'] = $v;
      $rtn .= $tpl->tbHtml($sFile, 'SELECT_THEME_LIST');
    }
    $rtn .= $tpl->tbHtml($sFile, 'SELECT_THEME_FOOT');
    unset($aThemes, $n, $v);
    return $rtn;
  }
}

if( !function_exists( 'templatesUpload' )){
  function templatesUpload($form,$sTheme,&$sTemplate){
    $msg = array(); $submitted = false;
    $iCount = count($_FILES['sFile']['name']);
    for($i=0;$i<$iCount;$i++){ if($_FILES['sFile']['name'][$i] != '') $submitted = true; }
    if($submitted){
      $oFJ = new FileJobs();
      $tdir = $GLOBALS['config']['dir_tpl'].($sTheme=='default'?'':"{$GLOBALS['config']['themesFolder']}/$sTheme/");
      if(is_dir($tdir)){
        for($i=0;$i<$iCount;$i++){
          if($_FILES['sFile']['name'][$i]!=''){
            $aFile = array('tmp_name'=>$_FILES['sFile']['tmp_name'][$i], 'name'=>$_FILES['sFile']['name'][$i]);
            $sExt = $oFJ->throwExtOfFile($aFile['name']);
            $sDestDir = false;
            if(in_array($sExt, array_map('strtolower', $GLOBALS['config']['image_suffixes']))){
              $sDestDir = checkTemplateDir("{$tdir}img/"); // all images go in the img folder, even 'admin' ones!
              $sTemplate = ''; // assume the upload is successful and show the user the image list - which means ensuring the template is Shop
            }elseif(in_array($sExt, array_map('strtolower',$GLOBALS['config']['template_suffixes']))){
              $sDestDir = checkTemplateDir(rtrim($tdir.$sTemplate,'/').'/');
            }elseif(in_array($sExt, array_map('strtolower',$GLOBALS['config']['css_suffixes']))){
              $sDestDir = checkTemplateDir(rtrim($tdir.$sTemplate,'/').'/');
            }
            if(!$sDestDir){
              $msg[] = "{$aFile['name']} {$GLOBALS['lang']['Upload_failSuffix']}";
            }else{
              $aFile['name'] = substr($aFile['name'],0,((-1)*strlen($sExt))) . $sExt;
              $result = $oFJ->uploadFile($aFile, $sDestDir);
              if(!$result) $msg[] = "{$aFile['name']} {$GLOBALS['lang']['Upload_failPerm']}";
            }
          }
        }
      }else{
        $msg[] = $GLOBALS['lang']['Upload_failDir'];
      }
    }
    return (count($msg) > 0 ? implode('<br />', $msg) : $submitted);
  }
}

if(!function_exists('checkTemplateDir')){
  function checkTemplateDir($dir){
    if(!is_dir($dir)){
      if(mkdir($dir)){
        if(chmod($dir,0777)){
          return $dir;
        }
      }
      return false;
    }else{
      return $dir;
    }
  }
}

if( !function_exists( 'throwSelectTemplateSuffix' ) ){
  function throwSelectTemplateSuffix($tplFile='templateEdit.tpl',$match=''){
    global $tpl,$aTemplate;
    
    $aTemplate = array();
    $ar = array_merge($GLOBALS['config']['template_suffixes'], $GLOBALS['config']['css_suffixes']);
    sort($ar);
    $content = $tpl->tbHtml($tplFile, 'SELECT_SUFFIX_HEAD');
    foreach($ar as $aTemplate['option']){
      $aTemplate['selected'] = ($aTemplate['option']==$match) ? "selected='selected'" : "";
      $content .= $tpl->tbHtml($tplFile, 'SELECT_SUFFIX_LIST');
    }
    $content .= $tpl->tbHtml($tplFile, 'SELECT_SUFFIX_FOOT');
    return $content;
  }
}

if( !function_exists( 'throwTemplate' ) ){
  function throwTemplate($sTheme,$sTemplate,$sFile,$tplFile='templateEdit.tpl'){
    
    $aReturn = array('name'=>(($sTemplate=='')?$GLOBALS['lang']['shop']:$GLOBALS['lang'][$sTemplate]), 'file'=>$sFile, 'theme'=>$sTheme);
    $aReturn['path'] = rtrim($GLOBALS['config']['dir_tpl'].($sTheme=='default'?'':"{$GLOBALS['config']['themesFolder']}/$sTheme/").$sTemplate,'/')."/$sFile";
    if(($pos = strrpos($sFile,'.'))!==false){
      $aReturn['suffix'] = substr($sFile,$pos+1);
      $aReturn['stem'] = substr($sFile,0,$pos);
      $ar = array_merge($GLOBALS['config']['template_suffixes'], $GLOBALS['config']['css_suffixes']);
      $aReturn['suffixes'] = throwSelectTemplateSuffix($tplFile,$aReturn['suffix']);
      if(is_file($aReturn['path']) && in_array($aReturn['suffix'],$ar)){
        $aReturn['content'] = fixTplFileContents(file_get_contents($aReturn['path']));
      }
    }
    return $aReturn;
  }
}

if(!function_exists('fixTplFileContents')){
  function fixTplFileContents($txt){
    $sT = $txt;
    $aP = array();
    $pos = array(0,0,0);
    while( strpos( $sT, '$', $pos[1] ) )  {
      $pos[1] = strpos( $sT, '$', $pos[1] ) + 1;

      preg_match( '/\$[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\[\]x7f-\xff]*/', $sT, $aP );

      if( ereg( ']', $aP[0] ) )
        $pos[2] = $pos[1] + strpos( $aP[0], ']' );
      else
        $pos[2] = $pos[1] + strlen( $aP[0] ) - 1;

      $sVar = substr( $sT, $pos[1], $pos[2] - $pos[1] );
      $sT = substr( $sT, 0, $pos[1] - 1 ) .'{{'. $sVar .'}}'. substr( $sT, $pos[2] );
    } // end while
    $sT = addslashes(substr( $sT, 0 ));
    $sT = htmlspecialchars($sT);
    return $sT;
  }
}

if(!function_exists('unFixTplFileContents')){
  function unFixTplFileContents($txt){
    $sT = $txt;
    $sT = str_replace( '{{$','$', $sT );
    $sT = str_replace( '{{','$', $sT );
    $sT = str_replace( '}}','', $sT );
    $sT = stripslashes( $sT );
    return $sT;
  }
}

if( !function_exists( 'saveTemplate' ) ){
  /**
  * Save template
  * @return string
  * @param array  $aForm
  */
  function saveTemplate( $aForm ){
    global $oPlugMan;

    if(!isset($_POST['sFile']) || $_POST['sFile'] == '' || !preg_match('/^[\w0-9_]+[\w0-9_-]*[\w0-9]+$/',$_POST['sFile'])){
      return 'err1';
    }elseif(!isset($_POST['sSuffix']) || $_POST['sSuffix'] == '' || !preg_match('/^[\w0-9]+$/',$_POST['sSuffix'])){
      return 'err2';
    }elseif(!isset($_POST['sTemplate']) || ($_POST['sTemplate'] != '' && $_POST['sTemplate'] != 'admin')){
      return 'err3';
    }elseif(!isset($_POST['sTheme']) || !in_array($_POST['sTheme'],$oPlugMan->getThemes(true))){
      return 'err8';
    }

    $path = rtrim($GLOBALS['config']['dir_tpl'].($_POST['sTheme']=='default'?'':"{$GLOBALS['config']['themesFolder']}/{$_POST['sTheme']}/").$_POST['sTemplate'],'/');
    if(($path = checkTemplateDir($path)) !== false){ $path .= "/{$_POST['sFile']}.{$_POST['sSuffix']}"; }
    if(!file_exists($path) || is_writable($path)){
      $sT = stripslashes($_POST['sText']);
      if(($handle=@fopen($path,'wb')) === false){
        return 'err4';
      }elseif(fwrite($handle, $sT) === false){
        @fclose($handle);
        return 'err5';
      }
      fclose($handle);
    }else{
      return 'err6';
    }
    return 'save';
  } // end function saveTemplate
}

if( !function_exists( 'delTemplate' ) ){
  /**
  * Delete template file
  * @return boolean
  * @param string file
  */
  function delTemplate( $sFile ){
    if(substr($sFile,0,strlen($GLOBALS['config']['dir_tpl'])) == $GLOBALS['config']['dir_tpl']){
      if(is_file($sFile)){
        return (@unlink($sFile));
      }
    }
    return false;
  } // end function delTemplate
}

if( !function_exists( 'getFiles' ) ){
  /**
  * Get a list of the files in a directory matching the suffixes supplied
  * @return array
  * @param string $d (directory)
  * @param array $aSuffix (allowed suffixes)
  * @param boolean all files
  */
  function getFiles($d,$aSuffix,$bAll=false) {

    if(!$aSuffix || !is_array($aSuffix)) $aSuffix = array();
    $aLowerSuffix = array_map('strtolower', $aSuffix);
    $aFile = array();
    if(!$bAll && count($aSuffix)==0) return $aFile; // results from empty suffix array!

    if(is_dir($d)){
      $bWD = is_writable($d);
      if($handle=opendir($d)){
        while (($sName = readdir($handle))!==false) {
          $sPath = rtrim($d,'/')."/$sName";
          if(!is_dir($sPath) && !is_link($sPath)) {
            $sSuffix = (($sfx = strrpos($sName,'.'))!==false) ? substr($sName,$sfx+1) : '';
            if($bAll || in_array(strtolower($sSuffix),$aLowerSuffix)){
              $bWF = is_writable($sPath);
              $aFile[$sName] = array('path'=>$sPath,'dWrite'=>$bWD,'fWrite'=>$bWF);
            }
          }
        }
        closedir($handle);
      }
      ksort($aFile);
      reset($aFile);
    }
    return $aFile;
  } // end function getFiles
}

if( !function_exists( 'templateImageResize' ) ){
  /**
  * restrict height and width
  * @return string
  * @param string $p (path to image)
  * @param int $maxH
  * @param int $maxW
  */
  function templateImageResize(&$p, $maxH=16, $maxW=100){
    if(($size = @getimagesize($p)) !== false){
      if($size[1]>$maxH){
        $size[0] = (int)($size[0] / ($size[1] / $maxH));
        $size[1] = $maxH;
      }
      if($size[0]>$maxW){
        $size[1] = (int)($size[1] / ($size[0] / $maxW));
        $size[0] = $maxW;
      }
      $top = 16-$size[1];
      return "style='border:0px;padding-top:{$top}px;' height='{$size[1]}' width='{$size[0]}'";
    }else{
      return "style='border:0px;' height='16'";
    }
  } // end function templateImageResize
}

if(!function_exists('copyTheme')){
  /**
  * Copy one theme to another
  * @param string source theme
  * @param string new theme
  * @return integer zero if successful
  */
  function copyTheme($sTo,$sFrom){
    global $config;
    if($sTo == '' || $sTo == 'default') return 9;
    else{
      $sTo = trim(strip_tags(stripslashes($sTo)),'./');
      if(preg_match('/^[\w]+$/',$sTo) == 0) return 9;
    }
    $rtn = 0;
    $from = rtrim($config['dir_tpl'].($sFrom=='default'?'':$sFrom),'/');
    $to = $config['dir_tpl'].$config['themesFolder'].'/'.$sTo;
    if(!is_dir($from)) $rtn = 10;
    elseif(!themesFolderExists()) $rtn = 11;
    elseif(file_exists($to)) $rtn = 12;
    else{
      $aTPL = getFiles("$from/", $config['template_suffixes']);
      $aCSS = getFiles("$from/", $config['css_suffixes']);
      $aTPLa = getFiles("$from/admin/", $config['template_suffixes']);
      $aCSSa = getFiles("$from/admin/", $config['css_suffixes']);
      $aIMG = getFiles("$from/img/", $config['image_suffixes']);
      if(mkdir($to, 0777) && mkdir($to.'/img', 0777) && mkdir($to.'/admin', 0777)){
        foreach($aTPL as $k=>$v) copy($v['path'], "$to/$k");
        foreach($aCSS as $k=>$v) copy($v['path'], "$to/$k");
        foreach($aTPLa as $k=>$v) copy($v['path'], "$to/admin/$k");
        foreach($aCSSa as $k=>$v) copy($v['path'], "$to/admin/$k");
        foreach($aIMG as $k=>$v) copy($v['path'], "$to/img/$k");
      }else $rtn = 13;
    }
    return $rtn;
  } // end function copyTheme
}

if( !function_exists( 'removeTheme' ) ){
  /**
  * Delete entire theme
  * @param string theme
  * @return integer zero if successful
  */
  function removeTheme( $sT ){
    $rtn = 0;
    $remove = $GLOBALS['config']['dir_tpl'].$GLOBALS['config']['themesFolder']."/$sT/";
    if($sT == 'default' || !is_dir($remove) || !themesFolderExists()) $rtn = 8;
    else{
      $aALL = getFiles($remove,array(),true);
      $aIMG = getFiles($remove.'img/',array(),true);
      $aADM = getFiles($remove.'admin/',array(),true);
      $sTemp = '';
      foreach($aIMG as $k=>$v) delTemplate($v['path'], $sTemp);
      foreach($aADM as $k=>$v) delTemplate($v['path'], $sTemp);
      foreach($aALL as $k=>$v) delTemplate($v['path'], $sTemp);
      $d1 = @rmdir($remove.'img/');
      $d2 = @rmdir($remove.'admin/');
      $d3 = @rmdir($remove);
//      if(!$d1 || !$d2 || !$d3) $rtn = 14;
    }
    return $rtn;
  } // end function removeTheme
}

if(!function_exists( 'themesFolderExists' )){
  /**
  * Checks for, and creates if nedded, the Themes Folder
  * @return boolean
  */
  function themesFolderExists(){
    $tf = $GLOBALS['config']['dir_tpl'].$GLOBALS['config']['themesFolder'];
    if(!is_dir($tf)){ $rtn = mkdir($tf,'0777'); }
    elseif(!is_writable($tf)){ $rtn = chmod($tf,'0777'); }
    else{ $rtn = true; }
    return $rtn;
  }
}
?>
